## pgn-extract 15.0

=== Makefile ===
# Make file for the pgn-extract program.
#    Program: pgn-extract: a Portable Game Notation (PGN) extractor.
#    Copyright (C) 1994-2001 David Barnes
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 1, or (at your option)
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    David Barnes may be contacted as D.J.Barnes@ukc.ac.uk
#    http://www.cs.ukc.ac.uk/people/staff/djb/

OBJS=grammar.o lex.o map.o decode.o moves.o lists.o apply.o output.o eco.o\
	lines.o end.o main.o hashing.o argsfile.o mymalloc.o
DEBUGINFO=-g

# These flags are particularly severe on checking warnings.
# It may be that they are not all appropriate to your environment.
# For instance, not all environments have prototypes available for
# the standard library functions.

# Linux users might need to add -D__linux__ to these in order to
# use strcasecmp instead of strcmpi (cf output.c)

CFLAGS=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings $(DEBUGINFO)\
	-I/usr/local/lib/ansi-include
CC=gcc

# AIX 3.2 Users might like to use these alternatives for CFLAGS and CC.
# Thanks to Erol Basturk for providing them.
AIX_CFLAGS=-c -D_POSIX_SOURCE -D_XOPEN_SOURCE -D_ALL_SOURCE
AIX_CC=xlc

# Suppress auto extraction.
.SCCS_GET:

pgn-extract : $(OBJS)
	$(CC) $(DEBUGINFO) $(OBJS) -o pgn-extract

purify : $(OBJS)
	purify $(CC) $(DEBUGINFO) $(OBJS) -o pgn-extract

clean:
	rm -f core pgn-extract *.o

mymalloc.o : mymalloc.c mymalloc.h
	$(CC) $(CFLAGS) mymalloc.c

apply.o :  apply.c defs.h lex.h grammar.h typedef.h map.h bool.h apply.h taglist.h\
	   eco.h decode.h moves.h hashing.h mymalloc.h output.h
	$(CC) $(CFLAGS) apply.c

argsfile.o : argsfile.c argsfile.h bool.h defs.h typedef.h lines.h \
		taglist.h tokens.h lex.h moves.h eco.h apply.h output.h \
		lists.h
	$(CC) $(CFLAGS) argsfile.c

decode.o : decode.c defs.h typedef.h taglist.h lex.h bool.h decode.h lists.h \
            tokens.h mymalloc.h
	$(CC) $(CFLAGS) decode.c

eco.o :  eco.c defs.h lex.h typedef.h map.h bool.h eco.h taglist.h apply.h \
           mymalloc.h
	$(CC) $(CFLAGS) eco.c

end.o : end.c end.h bool.h defs.h typedef.h lines.h tokens.h lex.h mymalloc.h
	$(CC) $(CFLAGS) end.c

grammar.o : grammar.c bool.h defs.h typedef.h lex.h taglist.h map.h lists.h\
	    moves.h apply.h output.h tokens.h eco.h end.h grammar.h hashing.h \
	    mymalloc.h
	$(CC) $(CFLAGS) grammar.c

hashing.o : hashing.c hashing.h bool.h defs.h typedef.h tokens.h\
		taglist.h lex.h mymalloc.h
	$(CC) $(CFLAGS) hashing.c

lex.o : lex.c bool.h defs.h typedef.h tokens.h taglist.h map.h\
	lists.h decode.h moves.h lines.h grammar.h mymalloc.h apply.h\
	output.h
	$(CC) $(CFLAGS) lex.c

lines.o : lines.c bool.h lines.h mymalloc.h
	$(CC) $(CFLAGS) lines.c

lists.o :  lists.c lists.h taglist.h bool.h defs.h typedef.h mymalloc.h
	$(CC) $(CFLAGS) lists.c

main.o : main.c bool.h defs.h typedef.h tokens.h taglist.h lex.h moves.h\
	   map.h lists.h output.h end.h grammar.h hashing.h \
	   argsfile.h mymalloc.h
	$(CC) $(CFLAGS) main.c

map.o :  map.c defs.h lex.h typedef.h map.h bool.h decode.h taglist.h \
         mymalloc.h
	$(CC) $(CFLAGS) map.c

moves.o :  moves.c defs.h typedef.h lex.h bool.h map.h lists.h moves.h apply.h\
	   lines.h taglist.h mymalloc.h
	$(CC) $(CFLAGS) moves.c

output.o :  output.c output.h taglist.h bool.h typedef.h defs.h lex.h grammar.h\
	    apply.h
	$(CC) $(CFLAGS) output.c

## pgn-extract 16.0

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Make file for the pgn-extract program.
 #    Program: pgn-extract: a Portable Game Notation (PGN) extractor.
-#    Copyright (C) 1994-2001 David Barnes
+#    Copyright (C) 1994-2005 David Barnes
 #    This program is free software; you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
 #    the Free Software Foundation; either version 1, or (at your option)
@@ -15,8 +15,8 @@
 #    along with this program; if not, write to the Free Software
 #    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 #
-#    David Barnes may be contacted as D.J.Barnes@ukc.ac.uk
-#    http://www.cs.ukc.ac.uk/people/staff/djb/
+#    David Barnes may be contacted as D.J.Barnes@kent.ac.uk
+#    http://www.cs.kent.ac.uk/people/staff/djb/
 
 OBJS=grammar.o lex.o map.o decode.o moves.o lists.o apply.o output.o eco.o\
 	lines.o end.o main.o hashing.o argsfile.o mymalloc.o
@@ -30,7 +30,10 @@
 # Linux users might need to add -D__linux__ to these in order to
 # use strcasecmp instead of strcmpi (cf output.c)
 
-CFLAGS=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
+# Mac OS X users might need to add  -D__unix__ to CFLAGS
+# and use CC=cc
+
+CFLAGS+=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
 	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings $(DEBUGINFO)\
 	-I/usr/local/lib/ansi-include
 CC=gcc

## pgn-extract 16.7

=== Makefile ===
--- 
+++ 
@@ -112,6 +112,6 @@
 	$(CC) $(CFLAGS) moves.c
 
 output.o :  output.c output.h taglist.h bool.h typedef.h defs.h lex.h grammar.h\
-	    apply.h
+	    apply.h mymalloc.h
 	$(CC) $(CFLAGS) output.c

=== debian/changelog ===
pgn-extract (16.7-2) unstable; urgency=low

  * debian/copyright:
    - Update to new DEP5 revision, some fields have been renamed
    - Remove the complete GPL-1 text and refer to
    /usr/share/common-licenses/GPL-1 instead.
  * debian/control:
    - Bump to Standards-Version 3.9.2 (No changes required)
    - Update my email address

 -- Vincent Legout <vlegout@debian.org>  Mon, 07 Nov 2011 20:45:03 +0100

pgn-extract (16.7-1) unstable; urgency=low

  * New upstream release
  * New maintainer (Closes:# 561252)
  * debian/compat: Bumped to 7
  * debian/control:
    - Add myself in Maintainer
    - Add Homepage field
    - Bump Standards-Version to 3.8.3
    - Add ${misc:Depends}
  * debian/copyright: Updated to DEP-5
  * debian/doc-base: Update Section
  * debian/dirs: Removed
  * debian/docs: Add help.html, Remove README
  * debian/lintian: Removed
  * debian/pgn-extract.man: Remove reference to README, Fix lintian warnings
  * debian/rules: Rewritten using dh
    - Add pgn-extract.install, pgn-extract.manpages
  * debian/watch: Added
  * Switch to 3.0 (quilt) source format

 -- Vincent Legout <vincent@legout.info>  Mon, 04 Jan 2010 21:28:07 +0100

pgn-extract (16.0-1) unstable; urgency=low

  * New upstream version: a few bug fixes and the - Welalg flag.
  * Updated manual page.
  * Updated standards version.

 -- Peter van Rossum <petervr@debian.org>  Mon, 11 Sep 2006 07:53:11 +0200

pgn-extract (15.0-4) unstable; urgency=low

  * Fixed short description.

 -- Peter van Rossum <petervr@debian.org>  Tue, 18 Jan 2005 19:50:45 +0100

pgn-extract (15.0-3) unstable; urgency=low

  * Fixed compiler warnings.
  * Updated policy to 3.6.1.
  * Rephrased copyright file and referred to new FSF address.

 -- Peter van Rossum <petervr@debian.org>  Wed, 24 Dec 2003 20:54:45 -0800

pgn-extract (15.0-2) unstable; urgency=low

  * Registered documentation with the documentation system.
  * Removed the (debhelper) /usr/doc symlink handling.

 -- Peter van Rossum <petervr@debian.org>  Thu, 17 Apr 2003 13:08:27 -0600

pgn-extract (15.0-1) unstable; urgency=low

  * New upstream version (finally uploaded).

 -- Peter van Rossum <petervr@debian.org>  Tue, 23 Oct 2001 12:21:40 -0700

pgn-extract (13.8-2) unstable; urgency=low

  * Changed section to games.
  * Fixed default location of eco-file. (Closes: #93282)

 -- Peter van Rossum <petervr@debian.org>  Mon,  9 Apr 2001 21:54:26 +0200

pgn-extract (13.8-1) unstable; urgency=low

  * New upstream version.
  * Closing the ITP bug against wnpp. (Closes: #90978)

 -- Peter van Rossum <petervr@debian.org>  Sun, 25 Mar 2001 14:14:12 +0200

pgn-extract (13.6-1) unstable; urgency=low

  * Initial Release.

 -- Peter van Rossum <petervr@sci.kun.nl>  Sat, 10 Mar 2001 20:13:16 +0100

=== debian/control ===
Source: pgn-extract
Section: games
Priority: optional
Maintainer: Vincent Legout <vlegout@debian.org>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.2
Homepage: http://www.cs.kent.ac.uk/people/staff/djb/pgn-extract/

Package: pgn-extract
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Portable Game Notation (PGN) extractor
 Pgn-extract is a program to extract selected games from a collection of
 chess games in PGN format. There are several ways to specify the criteria
 on which to extract: textual move sequences, the position reached after a
 sequence of moves, information in the tag fields, and material balance in
 the ending.

## pgn-extract 17.13

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Make file for the pgn-extract program.
 #    Program: pgn-extract: a Portable Game Notation (PGN) extractor.
-#    Copyright (C) 1994-2005 David Barnes
+#    Copyright (C) 1994-2013 David Barnes
 #    This program is free software; you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
 #    the Free Software Foundation; either version 1, or (at your option)
@@ -19,7 +19,7 @@
 #    http://www.cs.kent.ac.uk/people/staff/djb/
 
 OBJS=grammar.o lex.o map.o decode.o moves.o lists.o apply.o output.o eco.o\
-	lines.o end.o main.o hashing.o argsfile.o mymalloc.o
+	lines.o end.o main.o hashing.o argsfile.o mymalloc.o fenmatcher.o
 DEBUGINFO=-g
 
 # These flags are particularly severe on checking warnings.
@@ -30,7 +30,7 @@
 # Linux users might need to add -D__linux__ to these in order to
 # use strcasecmp instead of strcmpi (cf output.c)
 
-# Mac OS X users might need to add  -D__unix__ to CFLAGS
+# Mac OS X users might need to add -D__unix__ to CFLAGS
 # and use CC=cc
 
 CFLAGS+=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
@@ -59,12 +59,12 @@
 	$(CC) $(CFLAGS) mymalloc.c
 
 apply.o :  apply.c defs.h lex.h grammar.h typedef.h map.h bool.h apply.h taglist.h\
-	   eco.h decode.h moves.h hashing.h mymalloc.h output.h
+	   eco.h decode.h moves.h hashing.h mymalloc.h output.h fenmatcher.h
 	$(CC) $(CFLAGS) apply.c
 
 argsfile.o : argsfile.c argsfile.h bool.h defs.h typedef.h lines.h \
 		taglist.h tokens.h lex.h moves.h eco.h apply.h output.h \
-		lists.h
+		lists.h mymalloc.h
 	$(CC) $(CFLAGS) argsfile.c
 
 decode.o : decode.c defs.h typedef.h taglist.h lex.h bool.h decode.h lists.h \
@@ -75,7 +75,8 @@
            mymalloc.h
 	$(CC) $(CFLAGS) eco.c
 
-end.o : end.c end.h bool.h defs.h typedef.h lines.h tokens.h lex.h mymalloc.h
+end.o : end.c end.h bool.h defs.h typedef.h lines.h tokens.h lex.h mymalloc.h \
+        apply.h grammar.h
 	$(CC) $(CFLAGS) end.c
 
 grammar.o : grammar.c bool.h defs.h typedef.h lex.h taglist.h map.h lists.h\
@@ -108,10 +109,14 @@
 	$(CC) $(CFLAGS) map.c
 
 moves.o :  moves.c defs.h typedef.h lex.h bool.h map.h lists.h moves.h apply.h\
-	   lines.h taglist.h mymalloc.h
+	   lines.h taglist.h mymalloc.h fenmatcher.h
 	$(CC) $(CFLAGS) moves.c
+
+fenmatcher.o : fenmatcher.c apply.h bool.h defs.h fenmatcher.h mymalloc.h typedef.h
+	$(CC) $(CFLAGS) fenmatcher.c
 
 output.o :  output.c output.h taglist.h bool.h typedef.h defs.h lex.h grammar.h\
 	    apply.h mymalloc.h
 	$(CC) $(CFLAGS) output.c
 
+

=== debian/changelog ===
pgn-extract (17.13-1) unstable; urgency=low

  * New upstream version
  * debian/rules: Add get-orig-source target
  * Set debhelper compatibility to 9
  * Standards-Version 3.9.4, no changes needed
  * Add makefile.patch to enable hardening flags
  * debian/copyright:
    - Use copyright format 1.0
    - Update copyright years
    - Add a paragraph for style.css
  * debian/pgn-extract.man: Updated, do not list all options, point to
    help.html instead.

 -- Vincent Legout <vlegout@debian.org>  Sun, 19 May 2013 20:06:54 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

get-orig-source:
	wget ftp://ftp.cs.kent.ac.uk/pub/djb/pgn-extract/pgn-extract-17-13.tgz
	tar zxvf pgn-extract-17-13.tgz
	mv pgn-extract pgn-extract-17.13
	tar czf pgn-extract_17.13.orig.tar.gz pgn-extract-17.13
	rm -rf pgn-extract-17.13 pgn-extract-17-13.tgz

## pgn-extract 17.14

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,8 @@
 
 CFLAGS+=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
 	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings $(DEBUGINFO)\
-	-I/usr/local/lib/ansi-include
+	-I/usr/local/lib/ansi-include \
+	-O3
 CC=gcc
 
 # AIX 3.2 Users might like to use these alternatives for CFLAGS and CC.

=== test/Makefile ===
# Makefile to run a battery of tests of the basic functionality of pgn-extract.
# Copyright (C) David J. Barnes, 2013
#
# Each test is run and then, where relevant, a comparison is made between
# the output files generated in the current directory and the 'oracle'
# files that exist in $(OUTPUT).
#
# Beware of case-insensitive filenames when testing flags that
# differ only in letter case. In general, double letters have been
# used for output-files generated from using upper-case flag letters.

PGN_EXTRACT=../pgn-extract
# Use for memory checking if valgrind is installed.
#PGN_EXTRACT=valgrind --dsymutil=yes ../pgn-extract

# Location of the file of ECO classifications.
ECO_FILE=../eco.pgn

# Location of the input files
INPUT=infiles
# Location of the oracle output files
OUTPUT=outfiles

# Test everything.
all: no-flags-1 no-flags-2 test-7 test-append test-AA test-bl45 \
     test-bu45 test-bu30 test-checkfile test-nocomments test-duplicates \
     test-noduplicates test-e test-EE test-f test-FF test-h test-l \
     test-LL test-checkmate test-n test-NN test-output test-PP test-r \
     test-RR test-s test-SS test-t test-TT test-nounique test-v \
     test-VV test-linelength test-WW test-x test-ZZ test-z test-hash \
     test-evaluation test-fencomments test-markmatches test-nochecks \
     test-nomovenumbers test-noresults test-notags test-plylimit \
     test-stalemate test-long-line

# BEWARE: This removes all PGN files in the current directory.
# The required test PGN files are assumed to be in $(INPUT).
clean:
	-rm *.pgn *og.txt

# No flags:
#     + No input file.
#     - Input file(s): N/A
#     - Example input:
#       f3 e5 g4 Qh4 0-1
#     - Resulting output should be that the game input on standard input is
#       formatted as PGN on standard output.
#     - Expected output: 
#       Contents of fools-mate.pgn on standard output.
no-flags-1:
	echo "test: No input file."
	$(PGN_EXTRACT) < $(INPUT)/fools-mate.txt

# No flags:
#     + Single input file
#     - Input file(s): fools-mate.txt
#     - Resulting output should be the input formatted as PGN on standard output.
#     - Expected output: Contents of fools-mate.pgn should appear on standard output.
no-flags-2:
	echo "test: No flags."
	$(PGN_EXTRACT) $(INPUT)/fools-mate.txt

# -7 / --seven
#     + Input file with games having tags additional to the seven tag roster.
#     - Input file(s): test-7.pgn
#     - Game output should have only the tags of the seven tag roster.
#     - Expected output: test-7-out.pgn
test-7:
	echo "test-7:"
	$(PGN_EXTRACT) -7 -otest-7-out.pgn $(INPUT)/test-7.pgn
	-cmp test-7-out.pgn $(OUTPUT)/test-7-out.pgn

# -a / --append
#     + Input file containing games in any accepted format.
#     - Input file(s): test-a.txt
#     - Resulting output should contain two versions of the input game
#       formatted in PGN. The --output command is run first to create
#       a new file, then the -a version to append to that file.
#     - Expected output: test-a-out.pgn
test-append:
	echo "test-append:"
	$(PGN_EXTRACT) --output test-a-out.pgn $(INPUT)/test-a.txt
	$(PGN_EXTRACT) -atest-a-out.pgn $(INPUT)/test-a.txt
	-cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn

	$(PGN_EXTRACT) --output test-a-out.pgn $(INPUT)/test-a.txt
	$(PGN_EXTRACT) --append test-a-out.pgn $(INPUT)/test-a.txt
	-cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn

# -A
#     + Input file containing games and a file of arguments.
#     - Input file(s): fischer.pgn, petrosian.pgn, arglist.txt
#     - Resulting output should be files separating the unique and
#       duplicated games in the input files.
#     - Expected output: test-AA-unique.pgn, test-AA-dupes.pgn
test-AA:
	echo "test-A:"
	$(PGN_EXTRACT) -A$(INPUT)/argslist.txt
	-cmp test-AA-dupes.pgn $(OUTPUT)/test-AA-dupes.pgn
	-cmp test-AA-unique.pgn $(OUTPUT)/test-AA-unique.pgn

# -b
#     + Input file containing games of different length.
#     - Input file(s): fischer.pgn
#     - Resulting output: games whose number of moves is within
#       the specified bounds.
# 
test-b: test-bl45 test-bu45 test-bu30

#     - Expected output: 45 moves or more: test-bl45-out.pgn
test-bl45:
	echo "test-b:"
	$(PGN_EXTRACT) -bl45 -s -otest-bl45-out.pgn $(INPUT)/fischer.pgn
	-cmp test-bl45-out.pgn $(OUTPUT)/test-bl45-out.pgn

#     - Expected output: 45 moves or less: test-bu45-out.pgn
test-bu45:
	echo "test-b:"
	$(PGN_EXTRACT) -bu45 -s -otest-bu45-out.pgn $(INPUT)/fischer.pgn
	-cmp test-bu45-out.pgn $(OUTPUT)/test-bu45-out.pgn

#     - Expected output: exactly 30 moves: test-b30-out.pgn
test-bu30:
	echo "test-b:"
	$(PGN_EXTRACT) -b30 -s -otest-b30-out.pgn $(INPUT)/fischer.pgn
	-cmp test-b30-out.pgn $(OUTPUT)/test-b30-out.pgn

# 
# -c / --checkfile
#     + Input files containing games.
#     - Input file(s): fischer.pgn, petrosian.pgn
#     - Resulting output should contain matched games that do not already occur in
#       the check file.
#     - Expected output: test-c-out.pgn
test-checkfile:
	echo "test-checkfile:"
	$(PGN_EXTRACT) -c$(INPUT)/petrosian.pgn -D -TpPetrosian -otest-c-out.pgn $(INPUT)/fischer.pgn
	-cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn
	$(PGN_EXTRACT) -c$(INPUT)/clist.txt -D -TpPetrosian -otest-c-out.pgn $(INPUT)/fischer.pgn
	-cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn

# -C / --nocomments
#     + Input file containing games with comments
#     - Input file(s): test-C.pgn
#     - Resulting output should have all comments removed.
#     - Expected output: test-CC-out.pgn
test-nocomments:
	echo "test-nocomments:"
	$(PGN_EXTRACT) -C -otest-CC-out.pgn $(INPUT)/test-C.pgn
	-cmp test-CC-out.pgn $(OUTPUT)/test-CC-out.pgn

# -d / --duplicates
#     + Input file containing games with duplicates and non-duplicates.
#     - Input file(s): fischer.pgn, $(INPUT)/petrosian.pgn
#     - Resulting output should be files separating the unique and
#       duplicated games in the input files.
#     - Expected output: test-d-unique.pgn, test-d-dupes.pgn
test-duplicates:
	echo "test-duplicates:"
	$(PGN_EXTRACT) -dtest-d-dupes.pgn -s -otest-d-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
	-cmp test-d-dupes.pgn $(OUTPUT)/test-d-dupes.pgn
	-cmp test-d-unique.pgn $(OUTPUT)/test-d-unique.pgn

# -D / --noduplicates
#     + Input file containing games with duplicates and non-duplicates.
#     - Input file(s): fischer.pgn, $(INPUT)/petrosian.pgn
#     - Resulting output should be a file containing the combined input
#       with duplicate games removed.
#     - Expected output: test-DD-unique.pgn
test-noduplicates:
	echo "test-noduplicates:"
	$(PGN_EXTRACT) -D -s -otest-DD-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
	-cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn
	$(PGN_EXTRACT) --noduplicates -s -otest-DD-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
	-cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn

# -e
#     + Input file containing games without ECO classifications.
#     - Input file(s): test-e.pgn and eco.pgn in the test folder.
#     - Resulting output should have ECO classification added to the tags.
#     - Expected output: test-e-out.pgn
test-e:
	echo "test-e:"
	$(PGN_EXTRACT) -e$(ECO_FILE) -otest-e-out.pgn $(INPUT)/test-e.pgn
	-cmp test-e-out.pgn $(OUTPUT)/test-e-out.pgn

# -E
#     + Input file containing games.
#     - Input file(s): test-E.pgn and eco.pgn if -e flag is used.
#     - Resulting output should be separate files for each ECO classification
#       at the level of the initial letter (A-E).
#     - Expected output: A.pgn, B.pgn, E.pgn
test-EE:
	echo "test-E:"
	$(PGN_EXTRACT) -e$(ECO_FILE) -E1 $(INPUT)/test-E.pgn
	-cmp A.pgn $(OUTPUT)/A.pgn
	-cmp B.pgn $(OUTPUT)/B.pgn
	-cmp E.pgn $(OUTPUT)/E.pgn

# -f
#     + Input files containing games.
#     - Input file(s): test-f1.pgn, test-f2.pgn, files.txt
#     - Resulting output should be the combination of the input files.
#     - Expected output: test-f-out.pgn
test-f:
	echo "test-f:"
	$(PGN_EXTRACT) -f$(INPUT)/files.txt -otest-f-out.pgn
	-cmp test-f-out.pgn $(OUTPUT)/test-f-out.pgn

# -F:
#     + Input file containing games without a trailing FEN comment.
#     - Input file(s): test-F.pgn
#     - Resulting output should have a comment at the end containing
#       the FEN description of the final position.
#     - Expected output: test-FF-out.pgn
test-FF:
	echo "test-F:"
	$(PGN_EXTRACT) -F -otest-FF-out.pgn $(INPUT)/test-F.pgn
	-cmp test-FF-out.pgn $(OUTPUT)/test-FF-out.pgn

# 
# -h / -? / --help
#     + No input required.
#     - Input file(s): N/A
#     - Resulting output should be a description of how to use pgn-extract
#     - Expected output: N/A
# Also:
# 	../pgn-extract -?
# 	../pgn-extract --help
test-h:
	echo "test-h:"
	-$(PGN_EXTRACT) -h

# -l
#     + Input file containing games.
#     - Input file(s): fischer.pgn
#     - Resulting output: List of games parsed written to log.txt
#     - Expected output: log.txt
test-l:
	echo "test-l:"
	$(PGN_EXTRACT) -llog.txt -otest-l-out.pgn $(INPUT)/fischer.pgn
	-cmp log.txt $(OUTPUT)/log.txt
	-cmp test-l-out.pgn $(OUTPUT)/test-l-out.pgn

# -L
#     + Input file containing games.
#     - Input file(s): test-L1.pgn, test-L2.pgn
#     - Resulting output should be that log.txt contains the combined
#       logs from two runs of pgn-extract.
#     - Expected output: log.txt
test-LL:
	echo "test-L:"
	$(PGN_EXTRACT) -lLLog.txt -r $(INPUT)/test-L1.pgn
	$(PGN_EXTRACT) -LLLog.txt -r $(INPUT)/test-L2.pgn
	-cmp LLog.txt $(OUTPUT)/LLog.txt

# -M / --checkmate
#     + Input file containing games.
#     - Input file(s): test-checkmate.pgn
#     - Resulting output should contain only those games that end in checkmate.
#     - Expected output: test-checkmate-out.pgn
test-checkmate:
	echo "test-checkmate:"
	$(PGN_EXTRACT) --checkmate -otest-checkmate-out.pgn $(INPUT)/test-checkmate.pgn
	-cmp test-checkmate-out.pgn $(OUTPUT)/test-checkmate-out.pgn

# -n
#     + Input file containing games.
#     - Input file(s): petrosian.pgn
#     - Resulting output should be separate files containing matched
#       and non-matched games.
#     - Expected output: test-n-matched.pgn, test-n-unmatched.pgn
test-n:
	echo "test-n:"
	$(PGN_EXTRACT) -TpFischer -otest-n-matched.pgn -ntest-n-unmatched.pgn $(INPUT)/petrosian.pgn
	-cmp test-n-matched.pgn $(OUTPUT)/test-n-matched.pgn
	-cmp test-n-unmatched.pgn $(OUTPUT)/test-n-unmatched.pgn

# -N / --nonags
#     + Input file containing games with NAGs.
#     - Input file(s): test-N.pgn
#     - Resulting output should have all NAGs removed.
#     - Expected output: test-NN-out.pgn
test-NN:
	echo "test-N:"
	$(PGN_EXTRACT) -N -otest-NN-out.pgn $(INPUT)/test-N.pgn
	-cmp test-NN-out.pgn $(OUTPUT)/test-NN-out.pgn

# 
# -o / --output
#     + Input file containing games in any accepted format.
#     - Input file(s): test-o.txt
#     - Resulting output should contain the input game formatted in PGN.
#     - Expected output: test-o-out.pgn
test-output:
	echo "test-output:"
	$(PGN_EXTRACT) -otest-o-out.pgn $(INPUT)/test-o.txt
	-cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn
	$(PGN_EXTRACT) --output test-o-out.pgn $(INPUT)/test-o.txt
	-cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn

# -P
#     + Input file containing games with different sequences for the same
#       opening.
#     - Input file(s): test-P.pgn, Pvars.txt
#     - Resulting output should be games whose opening move exactly match
#       the sequence specified in Pvars.txt
#     - Expected output: test-PP-out.pgn
test-PP:
	echo "test-P:"
	$(PGN_EXTRACT) -P -v$(INPUT)/Pvars.txt -otest-PP-out.pgn $(INPUT)/test-P.pgn
	-cmp test-PP-out.pgn $(OUTPUT)/test-PP-out.pgn

# -r
#     + Input file containing games in any accepted format.
#     - Input file(s): test-r.text
#     - Resulting output should contain tag summary lines for the games
#       matched and a report of any errors.
#     - Expected output: test-r-log.txt
test-r:
	echo "test-r:"
	$(PGN_EXTRACT) -r -ltest-r-log.txt $(INPUT)/test-r.txt
	-cmp test-r-log.txt $(OUTPUT)/test-r-log.txt

# -R
#     + Input file containing games.

=== debian/changelog ===
pgn-extract (17.14-1) unstable; urgency=low

  * New upstream release
  * Update get-orig-source target
  * debian/patches/makefile.patch: Do not build with -03 by default and build
    using $(CPPFLAGS)

 -- Vincent Legout <vlegout@debian.org>  Sun, 29 Sep 2013 14:07:42 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: games
 Priority: optional
 Maintainer: Vincent Legout <vlegout@debian.org>
-Build-Depends: debhelper (>= 7)
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.4
 Homepage: http://www.cs.kent.ac.uk/people/staff/djb/pgn-extract/
 
 Package: pgn-extract

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

get-orig-source:
	wget ftp://ftp.cs.kent.ac.uk/pub/djb/pgn-extract/pgn-extract-17-14.tgz
	tar zxvf pgn-extract-17-14.tgz
	mv pgn-extract pgn-extract-17.14
	tar czf pgn-extract_17.14.orig.tar.gz pgn-extract-17.14
	rm -rf pgn-extract-17.14 pgn-extract-17-14.tgz

## pgn-extract 17.21

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Make file for the pgn-extract program.
 #    Program: pgn-extract: a Portable Game Notation (PGN) extractor.
-#    Copyright (C) 1994-2013 David Barnes
+#    Copyright (C) 1994-2015 David Barnes
 #    This program is free software; you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
 #    the Free Software Foundation; either version 1, or (at your option)
@@ -19,7 +19,8 @@
 #    http://www.cs.kent.ac.uk/people/staff/djb/
 
 OBJS=grammar.o lex.o map.o decode.o moves.o lists.o apply.o output.o eco.o\
-	lines.o end.o main.o hashing.o argsfile.o mymalloc.o fenmatcher.o
+	lines.o end.o main.o hashing.o argsfile.o mymalloc.o fenmatcher.o\
+	taglines.o
 DEBUGINFO=-g
 
 # These flags are particularly severe on checking warnings.
@@ -31,10 +32,11 @@
 # use strcasecmp instead of strcmpi (cf output.c)
 
 # Mac OS X users might need to add -D__unix__ to CFLAGS
-# and use CC=cc
+# and use CC=cc or CC=gcc
 
 CFLAGS+=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
-	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings $(DEBUGINFO)\
+	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings \
+	-Wsign-compare $(DEBUGINFO)\
 	-I/usr/local/lib/ansi-include \
 	-O3
 CC=gcc
@@ -43,9 +45,6 @@
 # Thanks to Erol Basturk for providing them.
 AIX_CFLAGS=-c -D_POSIX_SOURCE -D_XOPEN_SOURCE -D_ALL_SOURCE
 AIX_CC=xlc
-
-# Suppress auto extraction.
-.SCCS_GET:
 
 pgn-extract : $(OBJS)
 	$(CC) $(DEBUGINFO) $(OBJS) -o pgn-extract
@@ -64,7 +63,7 @@
 	$(CC) $(CFLAGS) apply.c
 
 argsfile.o : argsfile.c argsfile.h bool.h defs.h typedef.h lines.h \
-		taglist.h tokens.h lex.h moves.h eco.h apply.h output.h \
+		taglist.h tokens.h lex.h taglines.h moves.h eco.h apply.h output.h \
 		lists.h mymalloc.h
 	$(CC) $(CFLAGS) argsfile.c
 
@@ -120,4 +119,7 @@
 	    apply.h mymalloc.h
 	$(CC) $(CFLAGS) output.c
 
+taglines.o : taglines.c bool.h defs.h typedef.h tokens.h taglist.h lex.h lines.h \
+             lists.h moves.h output.h taglines.h
+	$(CC) $(CFLAGS) taglines.c

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Makefile to run a battery of tests of the basic functionality of pgn-extract.
-# Copyright (C) David J. Barnes, 2013
+# Copyright (C) David J. Barnes, 2013-2015
 #
 # Each test is run and then, where relevant, a comparison is made between
 # the output files generated in the current directory and the 'oracle'
@@ -30,7 +30,8 @@
      test-VV test-linelength test-WW test-x test-ZZ test-z test-hash \
      test-evaluation test-fencomments test-markmatches test-nochecks \
      test-nomovenumbers test-noresults test-notags test-plylimit \
-     test-stalemate test-long-line
+     test-stalemate test-long-line test-totalplycount test-addhashcode \
+     test-selectonly
 
 # BEWARE: This removes all PGN files in the current directory.
 # The required test PGN files are assumed to be in $(INPUT).
@@ -67,7 +68,7 @@
 test-7:
 	echo "test-7:"
 	$(PGN_EXTRACT) -7 -otest-7-out.pgn $(INPUT)/test-7.pgn
-	-cmp test-7-out.pgn $(OUTPUT)/test-7-out.pgn
+	cmp test-7-out.pgn $(OUTPUT)/test-7-out.pgn
 
 # -a / --append
 #     + Input file containing games in any accepted format.
@@ -80,11 +81,11 @@
 	echo "test-append:"
 	$(PGN_EXTRACT) --output test-a-out.pgn $(INPUT)/test-a.txt
 	$(PGN_EXTRACT) -atest-a-out.pgn $(INPUT)/test-a.txt
-	-cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn
+	cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn
 
 	$(PGN_EXTRACT) --output test-a-out.pgn $(INPUT)/test-a.txt
 	$(PGN_EXTRACT) --append test-a-out.pgn $(INPUT)/test-a.txt
-	-cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn
+	cmp test-a-out.pgn $(OUTPUT)/test-a-out.pgn
 
 # -A
 #     + Input file containing games and a file of arguments.
@@ -95,8 +96,8 @@
 test-AA:
 	echo "test-A:"
 	$(PGN_EXTRACT) -A$(INPUT)/argslist.txt
-	-cmp test-AA-dupes.pgn $(OUTPUT)/test-AA-dupes.pgn
-	-cmp test-AA-unique.pgn $(OUTPUT)/test-AA-unique.pgn
+	cmp test-AA-dupes.pgn $(OUTPUT)/test-AA-dupes.pgn
+	cmp test-AA-unique.pgn $(OUTPUT)/test-AA-unique.pgn
 
 # -b
 #     + Input file containing games of different length.
@@ -110,19 +111,19 @@
 test-bl45:
 	echo "test-b:"
 	$(PGN_EXTRACT) -bl45 -s -otest-bl45-out.pgn $(INPUT)/fischer.pgn
-	-cmp test-bl45-out.pgn $(OUTPUT)/test-bl45-out.pgn
+	cmp test-bl45-out.pgn $(OUTPUT)/test-bl45-out.pgn
 
 #     - Expected output: 45 moves or less: test-bu45-out.pgn
 test-bu45:
 	echo "test-b:"
 	$(PGN_EXTRACT) -bu45 -s -otest-bu45-out.pgn $(INPUT)/fischer.pgn
-	-cmp test-bu45-out.pgn $(OUTPUT)/test-bu45-out.pgn
+	cmp test-bu45-out.pgn $(OUTPUT)/test-bu45-out.pgn
 
 #     - Expected output: exactly 30 moves: test-b30-out.pgn
 test-bu30:
 	echo "test-b:"
 	$(PGN_EXTRACT) -b30 -s -otest-b30-out.pgn $(INPUT)/fischer.pgn
-	-cmp test-b30-out.pgn $(OUTPUT)/test-b30-out.pgn
+	cmp test-b30-out.pgn $(OUTPUT)/test-b30-out.pgn
 
 # 
 # -c / --checkfile
@@ -134,9 +135,9 @@
 test-checkfile:
 	echo "test-checkfile:"
 	$(PGN_EXTRACT) -c$(INPUT)/petrosian.pgn -D -TpPetrosian -otest-c-out.pgn $(INPUT)/fischer.pgn
-	-cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn
+	cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn
 	$(PGN_EXTRACT) -c$(INPUT)/clist.txt -D -TpPetrosian -otest-c-out.pgn $(INPUT)/fischer.pgn
-	-cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn
+	cmp test-c-out.pgn $(OUTPUT)/test-c-out.pgn
 
 # -C / --nocomments
 #     + Input file containing games with comments
@@ -146,7 +147,7 @@
 test-nocomments:
 	echo "test-nocomments:"
 	$(PGN_EXTRACT) -C -otest-CC-out.pgn $(INPUT)/test-C.pgn
-	-cmp test-CC-out.pgn $(OUTPUT)/test-CC-out.pgn
+	cmp test-CC-out.pgn $(OUTPUT)/test-CC-out.pgn
 
 # -d / --duplicates
 #     + Input file containing games with duplicates and non-duplicates.
@@ -157,8 +158,8 @@
 test-duplicates:
 	echo "test-duplicates:"
 	$(PGN_EXTRACT) -dtest-d-dupes.pgn -s -otest-d-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
-	-cmp test-d-dupes.pgn $(OUTPUT)/test-d-dupes.pgn
-	-cmp test-d-unique.pgn $(OUTPUT)/test-d-unique.pgn
+	cmp test-d-dupes.pgn $(OUTPUT)/test-d-dupes.pgn
+	cmp test-d-unique.pgn $(OUTPUT)/test-d-unique.pgn
 
 # -D / --noduplicates
 #     + Input file containing games with duplicates and non-duplicates.
@@ -169,9 +170,9 @@
 test-noduplicates:
 	echo "test-noduplicates:"
 	$(PGN_EXTRACT) -D -s -otest-DD-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
-	-cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn
+	cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn
 	$(PGN_EXTRACT) --noduplicates -s -otest-DD-unique.pgn $(INPUT)/fischer.pgn $(INPUT)/petrosian.pgn
-	-cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn
+	cmp test-DD-unique.pgn $(OUTPUT)/test-DD-unique.pgn
 
 # -e
 #     + Input file containing games without ECO classifications.
@@ -181,7 +182,7 @@
 test-e:
 	echo "test-e:"
 	$(PGN_EXTRACT) -e$(ECO_FILE) -otest-e-out.pgn $(INPUT)/test-e.pgn
-	-cmp test-e-out.pgn $(OUTPUT)/test-e-out.pgn
+	cmp test-e-out.pgn $(OUTPUT)/test-e-out.pgn
 
 # -E
 #     + Input file containing games.
@@ -192,9 +193,9 @@
 test-EE:
 	echo "test-E:"
 	$(PGN_EXTRACT) -e$(ECO_FILE) -E1 $(INPUT)/test-E.pgn
-	-cmp A.pgn $(OUTPUT)/A.pgn
-	-cmp B.pgn $(OUTPUT)/B.pgn
-	-cmp E.pgn $(OUTPUT)/E.pgn
+	cmp A.pgn $(OUTPUT)/A.pgn
+	cmp B.pgn $(OUTPUT)/B.pgn
+	cmp E.pgn $(OUTPUT)/E.pgn
 
 # -f
 #     + Input files containing games.
@@ -204,7 +205,7 @@
 test-f:
 	echo "test-f:"
 	$(PGN_EXTRACT) -f$(INPUT)/files.txt -otest-f-out.pgn
-	-cmp test-f-out.pgn $(OUTPUT)/test-f-out.pgn
+	cmp test-f-out.pgn $(OUTPUT)/test-f-out.pgn
 
 # -F:
 #     + Input file containing games without a trailing FEN comment.
@@ -215,7 +216,7 @@
 test-FF:
 	echo "test-F:"
 	$(PGN_EXTRACT) -F -otest-FF-out.pgn $(INPUT)/test-F.pgn
-	-cmp test-FF-out.pgn $(OUTPUT)/test-FF-out.pgn
+	cmp test-FF-out.pgn $(OUTPUT)/test-FF-out.pgn
 
 # 
 # -h / -? / --help
@@ -238,8 +239,8 @@
 test-l:
 	echo "test-l:"
 	$(PGN_EXTRACT) -llog.txt -otest-l-out.pgn $(INPUT)/fischer.pgn
-	-cmp log.txt $(OUTPUT)/log.txt
-	-cmp test-l-out.pgn $(OUTPUT)/test-l-out.pgn
+	cmp log.txt $(OUTPUT)/log.txt
+	cmp test-l-out.pgn $(OUTPUT)/test-l-out.pgn
 
 # -L
 #     + Input file containing games.
@@ -251,7 +252,7 @@
 	echo "test-L:"
 	$(PGN_EXTRACT) -lLLog.txt -r $(INPUT)/test-L1.pgn
 	$(PGN_EXTRACT) -LLLog.txt -r $(INPUT)/test-L2.pgn
-	-cmp LLog.txt $(OUTPUT)/LLog.txt
+	cmp LLog.txt $(OUTPUT)/LLog.txt
 
 # -M / --checkmate
 #     + Input file containing games.
@@ -261,7 +262,7 @@
 test-checkmate:
 	echo "test-checkmate:"
 	$(PGN_EXTRACT) --checkmate -otest-checkmate-out.pgn $(INPUT)/test-checkmate.pgn
-	-cmp test-checkmate-out.pgn $(OUTPUT)/test-checkmate-out.pgn
+	cmp test-checkmate-out.pgn $(OUTPUT)/test-checkmate-out.pgn
 
 # -n
 #     + Input file containing games.
@@ -272,8 +273,8 @@
 test-n:
 	echo "test-n:"
 	$(PGN_EXTRACT) -TpFischer -otest-n-matched.pgn -ntest-n-unmatched.pgn $(INPUT)/petrosian.pgn
-	-cmp test-n-matched.pgn $(OUTPUT)/test-n-matched.pgn
-	-cmp test-n-unmatched.pgn $(OUTPUT)/test-n-unmatched.pgn
+	cmp test-n-matched.pgn $(OUTPUT)/test-n-matched.pgn
+	cmp test-n-unmatched.pgn $(OUTPUT)/test-n-unmatched.pgn
 
 # -N / --nonags
 #     + Input file containing games with NAGs.
@@ -283,7 +284,7 @@
 test-NN:
 	echo "test-N:"
 	$(PGN_EXTRACT) -N -otest-NN-out.pgn $(INPUT)/test-N.pgn
-	-cmp test-NN-out.pgn $(OUTPUT)/test-NN-out.pgn
+	cmp test-NN-out.pgn $(OUTPUT)/test-NN-out.pgn
 
 # 
 # -o / --output
@@ -294,9 +295,9 @@
 test-output:
 	echo "test-output:"
 	$(PGN_EXTRACT) -otest-o-out.pgn $(INPUT)/test-o.txt
-	-cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn
+	cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn
 	$(PGN_EXTRACT) --output test-o-out.pgn $(INPUT)/test-o.txt
-	-cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn
+	cmp test-o-out.pgn $(OUTPUT)/test-o-out.pgn
 
 # -P
 #     + Input file containing games with different sequences for the same
@@ -308,7 +309,7 @@
 test-PP:
 	echo "test-P:"
 	$(PGN_EXTRACT) -P -v$(INPUT)/Pvars.txt -otest-PP-out.pgn $(INPUT)/test-P.pgn
-	-cmp test-PP-out.pgn $(OUTPUT)/test-PP-out.pgn
+	cmp test-PP-out.pgn $(OUTPUT)/test-PP-out.pgn
 
 # -r
 #     + Input file containing games in any accepted format.
@@ -319,7 +320,6 @@
 test-r:
 	echo "test-r:"
 	$(PGN_EXTRACT) -r -ltest-r-log.txt $(INPUT)/test-r.txt
-	-cmp test-r-log.txt $(OUTPUT)/test-r-log.txt
+	cmp test-r-log.txt $(OUTPUT)/test-r-log.txt
 
 # -R
-#     + Input file containing games.

=== debian/changelog ===
pgn-extract (17.21-1) unstable; urgency=medium

  * New upstream release
    - Update get-orig-source target
    - Refresh makefile.patch
  * debian/copyright: Update copyright years
  * Standards-Version 3.9.6
  * Install index.html

 -- Vincent Legout <vlegout@debian.org>  Thu, 28 May 2015 16:08:02 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Vincent Legout <vlegout@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://www.cs.kent.ac.uk/people/staff/djb/pgn-extract/
 
 Package: pgn-extract

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

get-orig-source:
	wget ftp://ftp.cs.kent.ac.uk/pub/djb/pgn-extract/pgn-extract-17-21.tgz
	tar zxvf pgn-extract-17-21.tgz
	mv pgn-extract pgn-extract-17.21
	tar czf pgn-extract_17.21.orig.tar.gz pgn-extract-17.21
	rm -rf pgn-extract-17.21 pgn-extract-17-21.tgz
